import _Object$keys from 'babel-runtime/core-js/object/keys';
import _typeof from 'babel-runtime/helpers/typeof';
import invariant from 'invariant';
import { Observable } from '@reactivex/rxjs';
import isObservable from 'fluorine-lib/lib/util/isObservable';

export default function combineStores(stores) {
  invariant((typeof stores === 'undefined' ? 'undefined' : _typeof(stores)) === 'object', 'combineStores: `stores` is expected to be an object containing Observables.');

  var keys = _Object$keys(stores);

  return Observable.combineLatest.apply(Observable, keys.map(function (key) {
    var store = stores[key];

    invariant(isObservable(store), 'combineStores: `stores` is expected to contain Observables only.');

    return store;
  }).concat([function () {
    for (var _len = arguments.length, values = Array(_len), _key = 0; _key < _len; _key++) {
      values[_key] = arguments[_key];
    }

    return values.reduce(function (acc, val, index) {
      acc[keys[index]] = val;
      return acc;
    }, {});
  }]));
}