export default function createGetter(state, emptyCollection, ids) {
  if (typeof ids === 'string') {
    return function getItem() {
      return state.get(ids);
    };
  }

  return function getItems() {
    return emptyCollection.withMutations(function (collection) {
      ids.forEach(function (id) {
        var item = state.get(id);
        if (item) {
          collection.set(id, item);
        }
      });
    });
  };
}